/* -*- Mode: C -*-
 *
 * File: mootm_cmdparser.c
 * Description: Code for command-line parser struct gengetopt_args_info.
 *
 * File autogenerated by optgen.perl version 0.04
 * generated with the following command:
 * /usr/bin/optgen.perl -u -l --nopod -F mootm_cmdparser mootm.gog
 *
 * The developers of optgen.perl consider the fixed text that goes in all
 * optgen.perl output files to be in the public domain:
 * we make no copyright claims on it.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>

/* If we use autoconf/autoheader.  */
#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#ifdef HAVE_PWD_H
# include <pwd.h>
#endif

/* Allow user-overrides for PACKAGE and VERSION */
#ifndef PACKAGE
#  define PACKAGE "PACKAGE"
#endif

#ifndef VERSION
#  define VERSION "VERSION"
#endif


#ifndef PROGRAM
# define PROGRAM "mootm"
#endif

/* #define cmdline_parser_DEBUG */

/* Check for "configure's" getopt check result.  */
#ifndef HAVE_GETOPT_LONG
# include "getopt.h"
#else
# include <getopt.h>
#endif

#if !defined(HAVE_STRDUP) && !defined(strdup)
# define strdup gengetopt_strdup
#endif /* HAVE_STRDUP */

#include "mootm_cmdparser.h"


/* user code section */

/* end user  code section */


void
cmdline_parser_print_version (void)
{
  printf("mootm (%s %s) by Bryan Jurish <moocow@ling.uni-potsdam.de>\n", PACKAGE, VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n");
  printf("Purpose:\n");
  printf("  Morphological analyzer for moocow's part-of-speech tagger.\n");
  printf("\n");
  
  printf("Usage: %s [OPTIONS]... INPUT(s)\n", "mootm");
  
  printf("\n");
  printf(" Arguments:\n");
  printf("   INPUT(s)  Input files / file-lists / words.\n");
  
  printf("\n");
  printf(" Options:\n");
  printf("   -h        --help           Print help and exit.\n");
  printf("   -V        --version        Print version and exit.\n");
  printf("   -cFILE    --rcfile=FILE    Read an alternate configuration file.\n");
  printf("   -vLEVEL   --verbose=LEVEL  Verbosity level.\n");
  printf("   -dNTOKS   --dots=NTOKS     Print a dot for every NTOKS tokens processed.\n");
  printf("   -w        --words          INPUTs are input tokens, not filenames.\n");
  printf("   -l        --list           INPUTs are file-lists, not filenames.\n");
  printf("   -oFILE    --output=FILE    Specify output file (default=stdout).\n");
  printf("\n");
  printf(" I/O Format Options:\n");
  printf("   -a        --avm            Produce AVM ('vector') output.\n");
  printf("   -r        --reanalyze      Force re-analysis of pre-analyzed tokens.\n");
  printf("   -1        --first-is-best  Assume 1st analysis is 'best' for each input token.\n");
  printf("   -2        --ignore-first   Ignore the first analysis for each input token.\n");
  printf("\n");
  printf(" Morphology Options:\n");
  printf("   -sFILE    --symbols=FILE   Specify morphological symbols file.\n");
  printf("   -mFILE    --morph=FILE     Specify morphological transducer.\n");
  printf("   -eSTRING  --eow=STRING     Specify implicit EOW string.\n");
}

#if !defined(HAVE_STRDUP) && !defined(strdup)
/* gengetopt_strdup(): automatically generated from strdup.c. */
/* strdup.c replacement of strdup, which is not standard */
static char *
gengetopt_strdup (const char *s)
{
  char *result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}
#endif /* HAVE_STRDUP */

/* clear_args(args_info): clears all args & resets to defaults */
static void
clear_args(struct gengetopt_args_info *args_info)
{
  args_info->rcfile_arg = NULL; 
  args_info->verbose_arg = 3; 
  args_info->dots_arg = 0; 
  args_info->words_flag = 0; 
  args_info->list_flag = 0; 
  args_info->output_arg = strdup("-"); 
  args_info->avm_flag = 0; 
  args_info->reanalyze_flag = 0; 
  args_info->first_is_best_flag = 0; 
  args_info->ignore_first_flag = 0; 
  args_info->symbols_arg = strdup("moot.sym"); 
  args_info->morph_arg = strdup("moot.fst"); 
  args_info->eow_arg = strdup(""); 
}


int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  int c;	/* Character of the parsed option.  */
  int missing_required_options = 0;	

  args_info->help_given = 0;
  args_info->version_given = 0;
  args_info->rcfile_given = 0;
  args_info->verbose_given = 0;
  args_info->dots_given = 0;
  args_info->words_given = 0;
  args_info->list_given = 0;
  args_info->output_given = 0;
  args_info->avm_given = 0;
  args_info->reanalyze_given = 0;
  args_info->first_is_best_given = 0;
  args_info->ignore_first_given = 0;
  args_info->symbols_given = 0;
  args_info->morph_given = 0;
  args_info->eow_given = 0;

  clear_args(args_info);

  /* rcfile handling */
  cmdline_parser_read_rcfile("/etc/mootmrc", args_info, 0);
  cmdline_parser_read_rcfile("~/.mootmrc", args_info, 0);
  /* end rcfile handling */

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      static struct option long_options[] = {
	{ "help", 0, NULL, 'h' },
	{ "version", 0, NULL, 'V' },
	{ "rcfile", 1, NULL, 'c' },
	{ "verbose", 1, NULL, 'v' },
	{ "dots", 1, NULL, 'd' },
	{ "words", 0, NULL, 'w' },
	{ "list", 0, NULL, 'l' },
	{ "output", 1, NULL, 'o' },
	{ "avm", 0, NULL, 'a' },
	{ "reanalyze", 0, NULL, 'r' },
	{ "first-is-best", 0, NULL, '1' },
	{ "ignore-first", 0, NULL, '2' },
	{ "symbols", 1, NULL, 's' },
	{ "morph", 1, NULL, 'm' },
	{ "eow", 1, NULL, 'e' },
        { NULL,	0, NULL, 0 }
      };
      static char short_options[] = {
	'h',
	'V',
	'c', ':',
	'v', ':',
	'd', ':',
	'w',
	'l',
	'o', ':',
	'a',
	'r',
	'1',
	'2',
	's', ':',
	'm', ':',
	'e', ':',
	'\0'
      };

      c = getopt_long (argc, argv, short_options, long_options, &option_index);

      if (c == -1) break;	/* Exit from 'while (1)' loop.  */

      if (cmdline_parser_parse_option(c, long_options[option_index].name, optarg, args_info) != 0) {
	exit (EXIT_FAILURE);
      }
    } /* while */

  

  if ( missing_required_options )
    exit (EXIT_FAILURE);

  
  if (optind < argc) {
      int i = 0 ;
      args_info->inputs_num = argc - optind ;
      args_info->inputs = (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = strdup (argv[optind++]) ; 
  }

  return 0;
}


/* Parse a single option */
int
cmdline_parser_parse_option(char oshort, const char *olong, const char *val,
			       struct gengetopt_args_info *args_info)
{
  if (!oshort && !(olong && *olong)) return 1;  /* ignore null options */

#ifdef cmdline_parser_DEBUG
  fprintf(stderr, "parse_option(): oshort='%c', olong='%s', val='%s'\n", oshort, olong, val);*/
#endif

  switch (oshort)
    {
      case 'h':	 /* Print help and exit. */
          if (args_info->help_given) {
            fprintf(stderr, "%s: `--help' (`-h') option given more than once\n", PROGRAM);
          }
          clear_args(args_info);
          cmdline_parser_print_help();
          exit(EXIT_SUCCESS);
        
          break;
        
        case 'V':	 /* Print version and exit. */
          if (args_info->version_given) {
            fprintf(stderr, "%s: `--version' (`-V') option given more than once\n", PROGRAM);
          }
          clear_args(args_info);
          cmdline_parser_print_version();
          exit(EXIT_SUCCESS);
        
          break;
        
        case 'c':	 /* Read an alternate configuration file. */
          if (args_info->rcfile_given) {
            fprintf(stderr, "%s: `--rcfile' (`-c') option given more than once\n", PROGRAM);
          }
          cmdline_parser_read_rcfile(val,args_info,1);
          break;
        
        case 'v':	 /* Verbosity level. */
          if (args_info->verbose_given) {
            fprintf(stderr, "%s: `--verbose' (`-v') option given more than once\n", PROGRAM);
          }
          args_info->verbose_given++;
          args_info->verbose_arg = (int)atoi(val);
          break;
        
        case 'd':	 /* Print a dot for every NTOKS tokens processed. */
          if (args_info->dots_given) {
            fprintf(stderr, "%s: `--dots' (`-d') option given more than once\n", PROGRAM);
          }
          args_info->dots_given++;
          args_info->dots_arg = (int)atoi(val);
          break;
        
        case 'w':	 /* INPUTs are input tokens, not filenames. */
          if (args_info->words_given) {
            fprintf(stderr, "%s: `--words' (`-w') option given more than once\n", PROGRAM);
          }
          args_info->words_given++;
         if (args_info->words_given <= 1)
           args_info->words_flag = !(args_info->words_flag);
          break;
        
        case 'l':	 /* INPUTs are file-lists, not filenames. */
          if (args_info->list_given) {
            fprintf(stderr, "%s: `--list' (`-l') option given more than once\n", PROGRAM);
          }
          args_info->list_given++;
         if (args_info->list_given <= 1)
           args_info->list_flag = !(args_info->list_flag);
          break;
        
        case 'o':	 /* Specify output file (default=stdout). */
          if (args_info->output_given) {
            fprintf(stderr, "%s: `--output' (`-o') option given more than once\n", PROGRAM);
          }
          args_info->output_given++;
          if (args_info->output_arg) free(args_info->output_arg);
          args_info->output_arg = strdup(val);
          break;
        
        case 'a':	 /* Produce AVM ('vector') output. */
          if (args_info->avm_given) {
            fprintf(stderr, "%s: `--avm' (`-a') option given more than once\n", PROGRAM);
          }
          args_info->avm_given++;
         if (args_info->avm_given <= 1)
           args_info->avm_flag = !(args_info->avm_flag);
          break;
        
        case 'r':	 /* Force re-analysis of pre-analyzed tokens. */
          if (args_info->reanalyze_given) {
            fprintf(stderr, "%s: `--reanalyze' (`-r') option given more than once\n", PROGRAM);
          }
          args_info->reanalyze_given++;
         if (args_info->reanalyze_given <= 1)
           args_info->reanalyze_flag = !(args_info->reanalyze_flag);
          break;
        
        case '1':	 /* Assume 1st analysis is 'best' for each input token. */
          if (args_info->first_is_best_given) {
            fprintf(stderr, "%s: `--first-is-best' (`-1') option given more than once\n", PROGRAM);
          }
          args_info->first_is_best_given++;
         if (args_info->first_is_best_given <= 1)
           args_info->first_is_best_flag = !(args_info->first_is_best_flag);
          break;
        
        case '2':	 /* Ignore the first analysis for each input token. */
          if (args_info->ignore_first_given) {
            fprintf(stderr, "%s: `--ignore-first' (`-2') option given more than once\n", PROGRAM);
          }
          args_info->ignore_first_given++;
         if (args_info->ignore_first_given <= 1)
           args_info->ignore_first_flag = !(args_info->ignore_first_flag);
          break;
        
        case 's':	 /* Specify morphological symbols file. */
          if (args_info->symbols_given) {
            fprintf(stderr, "%s: `--symbols' (`-s') option given more than once\n", PROGRAM);
          }
          args_info->symbols_given++;
          if (args_info->symbols_arg) free(args_info->symbols_arg);
          args_info->symbols_arg = strdup(val);
          break;
        
        case 'm':	 /* Specify morphological transducer. */
          if (args_info->morph_given) {
            fprintf(stderr, "%s: `--morph' (`-m') option given more than once\n", PROGRAM);
          }
          args_info->morph_given++;
          if (args_info->morph_arg) free(args_info->morph_arg);
          args_info->morph_arg = strdup(val);
          break;
        
        case 'e':	 /* Specify implicit EOW string. */
          if (args_info->eow_given) {
            fprintf(stderr, "%s: `--eow' (`-e') option given more than once\n", PROGRAM);
          }
          args_info->eow_given++;
          if (args_info->eow_arg) free(args_info->eow_arg);
          args_info->eow_arg = strdup(val);
          break;
        
        case 0:	 /* Long option(s) with no short form */
        /* Print help and exit. */
          if (strcmp(olong, "help") == 0) {
            if (args_info->help_given) {
              fprintf(stderr, "%s: `--help' (`-h') option given more than once\n", PROGRAM);
            }
            clear_args(args_info);
            cmdline_parser_print_help();
            exit(EXIT_SUCCESS);
          
          }
          
          /* Print version and exit. */
          else if (strcmp(olong, "version") == 0) {
            if (args_info->version_given) {
              fprintf(stderr, "%s: `--version' (`-V') option given more than once\n", PROGRAM);
            }
            clear_args(args_info);
            cmdline_parser_print_version();
            exit(EXIT_SUCCESS);
          
          }
          
          /* Read an alternate configuration file. */
          else if (strcmp(olong, "rcfile") == 0) {
            if (args_info->rcfile_given) {
              fprintf(stderr, "%s: `--rcfile' (`-c') option given more than once\n", PROGRAM);
            }
            cmdline_parser_read_rcfile(val,args_info,1);
          }
          
          /* Verbosity level. */
          else if (strcmp(olong, "verbose") == 0) {
            if (args_info->verbose_given) {
              fprintf(stderr, "%s: `--verbose' (`-v') option given more than once\n", PROGRAM);
            }
            args_info->verbose_given++;
            args_info->verbose_arg = (int)atoi(val);
          }
          
          /* Print a dot for every NTOKS tokens processed. */
          else if (strcmp(olong, "dots") == 0) {
            if (args_info->dots_given) {
              fprintf(stderr, "%s: `--dots' (`-d') option given more than once\n", PROGRAM);
            }
            args_info->dots_given++;
            args_info->dots_arg = (int)atoi(val);
          }
          
          /* INPUTs are input tokens, not filenames. */
          else if (strcmp(olong, "words") == 0) {
            if (args_info->words_given) {
              fprintf(stderr, "%s: `--words' (`-w') option given more than once\n", PROGRAM);
            }
            args_info->words_given++;
           if (args_info->words_given <= 1)
             args_info->words_flag = !(args_info->words_flag);
          }
          
          /* INPUTs are file-lists, not filenames. */
          else if (strcmp(olong, "list") == 0) {
            if (args_info->list_given) {
              fprintf(stderr, "%s: `--list' (`-l') option given more than once\n", PROGRAM);
            }
            args_info->list_given++;
           if (args_info->list_given <= 1)
             args_info->list_flag = !(args_info->list_flag);
          }
          
          /* Specify output file (default=stdout). */
          else if (strcmp(olong, "output") == 0) {
            if (args_info->output_given) {
              fprintf(stderr, "%s: `--output' (`-o') option given more than once\n", PROGRAM);
            }
            args_info->output_given++;
            if (args_info->output_arg) free(args_info->output_arg);
            args_info->output_arg = strdup(val);
          }
          
          /* Produce AVM ('vector') output. */
          else if (strcmp(olong, "avm") == 0) {
            if (args_info->avm_given) {
              fprintf(stderr, "%s: `--avm' (`-a') option given more than once\n", PROGRAM);
            }
            args_info->avm_given++;
           if (args_info->avm_given <= 1)
             args_info->avm_flag = !(args_info->avm_flag);
          }
          
          /* Force re-analysis of pre-analyzed tokens. */
          else if (strcmp(olong, "reanalyze") == 0) {
            if (args_info->reanalyze_given) {
              fprintf(stderr, "%s: `--reanalyze' (`-r') option given more than once\n", PROGRAM);
            }
            args_info->reanalyze_given++;
           if (args_info->reanalyze_given <= 1)
             args_info->reanalyze_flag = !(args_info->reanalyze_flag);
          }
          
          /* Assume 1st analysis is 'best' for each input token. */
          else if (strcmp(olong, "first-is-best") == 0) {
            if (args_info->first_is_best_given) {
              fprintf(stderr, "%s: `--first-is-best' (`-1') option given more than once\n", PROGRAM);
            }
            args_info->first_is_best_given++;
           if (args_info->first_is_best_given <= 1)
             args_info->first_is_best_flag = !(args_info->first_is_best_flag);
          }
          
          /* Ignore the first analysis for each input token. */
          else if (strcmp(olong, "ignore-first") == 0) {
            if (args_info->ignore_first_given) {
              fprintf(stderr, "%s: `--ignore-first' (`-2') option given more than once\n", PROGRAM);
            }
            args_info->ignore_first_given++;
           if (args_info->ignore_first_given <= 1)
             args_info->ignore_first_flag = !(args_info->ignore_first_flag);
          }
          
          /* Specify morphological symbols file. */
          else if (strcmp(olong, "symbols") == 0) {
            if (args_info->symbols_given) {
              fprintf(stderr, "%s: `--symbols' (`-s') option given more than once\n", PROGRAM);
            }
            args_info->symbols_given++;
            if (args_info->symbols_arg) free(args_info->symbols_arg);
            args_info->symbols_arg = strdup(val);
          }
          
          /* Specify morphological transducer. */
          else if (strcmp(olong, "morph") == 0) {
            if (args_info->morph_given) {
              fprintf(stderr, "%s: `--morph' (`-m') option given more than once\n", PROGRAM);
            }
            args_info->morph_given++;
            if (args_info->morph_arg) free(args_info->morph_arg);
            args_info->morph_arg = strdup(val);
          }
          
          /* Specify implicit EOW string. */
          else if (strcmp(olong, "eow") == 0) {
            if (args_info->eow_given) {
              fprintf(stderr, "%s: `--eow' (`-e') option given more than once\n", PROGRAM);
            }
            args_info->eow_given++;
            if (args_info->eow_arg) free(args_info->eow_arg);
            args_info->eow_arg = strdup(val);
          }
          
          else {
            fprintf(stderr, "%s: unknown long option '%s'.\n", PROGRAM, olong);
            return (EXIT_FAILURE);
          }
          break;

        case '?':	 /* Invalid Option */
          fprintf(stderr, "%s: unknown option '%s'.\n", PROGRAM, olong);
          return (EXIT_FAILURE);


        default:	/* bug: options not considered.  */
          fprintf (stderr, "%s: option unknown: %c\n", PROGRAM, oshort);
          abort ();
        } /* switch */
  return 0;
}


/* Initialize options not yet given from environmental defaults */
void
cmdline_parser_envdefaults(struct gengetopt_args_info *args_info)
{
  if (!args_info->symbols_given) {
    char *value = getenv("moot_SYMBOLS");
    if (value != NULL) {
        if (args_info->symbols_arg) free(args_info->symbols_arg);
        args_info->symbols_arg = strdup(value);
    }
  }
  if (!args_info->morph_given) {
    char *value = getenv("moot_MORPH");
    if (value != NULL) {
        if (args_info->morph_arg) free(args_info->morph_arg);
        args_info->morph_arg = strdup(value);
    }
  }
  if (!args_info->eow_given) {
    char *value = getenv("moot_EOW");
    if (value != NULL) {
        if (args_info->eow_arg) free(args_info->eow_arg);
        args_info->eow_arg = strdup(value);
    }
  }
  

  return;
}


/* Load option values from an .rc file */
void
cmdline_parser_read_rcfile(const char *filename,
			      struct gengetopt_args_info *args_info,
			      int user_specified)
{
  char *fullname;
  FILE *rcfile;

  if (!filename) return; /* ignore NULL filenames */

#if defined(HAVE_GETUID) && defined(HAVE_GETPWUID)
  if (*filename == '~') {
    /* tilde-expansion hack */
    struct passwd *pwent = getpwuid(getuid());
    if (!pwent) {
      fprintf(stderr, "%s: user-id %d not found!\n", PROGRAM, getuid());
      return;
    }
    if (!pwent->pw_dir) {
      fprintf(stderr, "%s: home directory for user-id %d not found!\n", PROGRAM, getuid());
      return;
    }
    fullname = (char *)malloc(strlen(pwent->pw_dir)+strlen(filename));
    strcpy(fullname, pwent->pw_dir);
    strcat(fullname, filename+1);
  } else {
    fullname = strdup(filename);
  }
#else /* !(defined(HAVE_GETUID) && defined(HAVE_GETPWUID)) */
  fullname = strdup(filename);
#endif /* defined(HAVE_GETUID) && defined(HAVE_GETPWUID) */

  /* try to open */
  rcfile = fopen(fullname,"r");
  if (!rcfile) {
    if (user_specified) {
      fprintf(stderr, "%s: warning: open failed for rc-file '%s': %s\n",
	      PROGRAM, fullname, strerror(errno));
    }
  }
  else {
   cmdline_parser_read_rc_stream(rcfile, fullname, args_info);
  }

  /* cleanup */
  if (fullname != filename) free(fullname);
  if (rcfile) fclose(rcfile);

  return;
}


/* Parse option values from an .rc file : guts */
#define OPTPARSE_GET 32
void
cmdline_parser_read_rc_stream(FILE *rcfile,
				 const char *filename,
				 struct gengetopt_args_info *args_info)
{
  char *optname  = (char *)malloc(OPTPARSE_GET);
  char *optval   = (char *)malloc(OPTPARSE_GET);
  size_t onsize  = OPTPARSE_GET;
  size_t ovsize  = OPTPARSE_GET;
  size_t onlen   = 0;
  size_t ovlen   = 0;
  int    lineno  = 0;
  char c;

#ifdef cmdline_parser_DEBUG
  fprintf(stderr, "cmdline_parser_read_rc_stream('%s'):\n", filename);
#endif

  while ((c = fgetc(rcfile)) != EOF) {
    onlen = 0;
    ovlen = 0;
    lineno++;

    /* -- get next option-name */
    /* skip leading space and comments */
    if (isspace(c)) continue;
    if (c == '#') {
      while ((c = fgetc(rcfile)) != EOF) {
	if (c == '\n') break;
      }
      continue;
    }

    /* parse option-name */
    while (c != EOF && c != '=' && !isspace(c)) {
      /* re-allocate if necessary */
      if (onlen >= onsize-1) {
	char *tmp = (char *)malloc(onsize+OPTPARSE_GET);
	strcpy(tmp,optname);
	free(optname);

	onsize += OPTPARSE_GET;
	optname = tmp;
      }
      optname[onlen++] = c;
      c = fgetc(rcfile);
    }
    optname[onlen++] = '\0';

#ifdef cmdline_parser_DEBUG
    fprintf(stderr, "cmdline_parser_read_rc_stream('%s'): line %d: optname='%s'\n",
	    filename, lineno, optname);
#endif

    /* -- get next option-value */
    /* skip leading space */
    while ((c = fgetc(rcfile)) != EOF && isspace(c)) {
      ;
    }

    /* parse option-value */
    while (c != EOF && c != '\n') {
      /* re-allocate if necessary */
      if (ovlen >= ovsize-1) {
	char *tmp = (char *)malloc(ovsize+OPTPARSE_GET);
	strcpy(tmp,optval);
	free(optval);
	ovsize += OPTPARSE_GET;
	optval = tmp;
      }
      optval[ovlen++] = c;
      c = fgetc(rcfile);
    }
    optval[ovlen++] = '\0';

    /* now do the action for the option */
    if (cmdline_parser_parse_option('\0',optname,optval,args_info) != 0) {
      fprintf(stderr, "%s: error in file '%s' at line %d.\n", PROGRAM, filename, lineno);
      
    }
  }

  /* cleanup */
  free(optname);
  free(optval);

  return;
}
